



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>腾讯云 COS 对象存储使用</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">腾讯云 COS 对象存储使用</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-20 12:33:45 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>目前使用腾讯云的对象存储<a href="https://cloud.tencent.com/document/product/436" rel="external nofollow noreferrer">cos服务</a>，将本地的文件同步到cos中，看了腾讯云的用户文档，发现使用<a href="https://cloud.tencent.com/document/product/436/15392" rel="external nofollow noreferrer">COS Migration 工具</a>还是挺适合的。</p>
<p><strong>原因</strong></p>
<p>因为服务器已经安装有java环境，而cos的几个用户工具中，用于自动同步的只看到这个工具，其他工具都需要额外的代码去调用命令，</p>
<p>从开箱即用的角度看，还是这个工具好用的。</p>
<p><strong>使用</strong></p>
<p>配置下./conf/config.ini。指定好同步周期后，运行脚本</p>
<div>
<pre class="prettyprint linenums"> sh start_migrate.sh</pre>
</div>
<p>因为是需要常驻运行，所以我这边是后台运行的</p>
<div>
<pre class="prettyprint linenums">nohup sh start_migrate.sh &gt;/dev/null 2&gt;&amp;1 &amp;</pre>
</div>
<p>命令大体意思是</p>
<ol><li><strong>nohup</strong> 表示后台运行</li>
<li><strong>sh start_migrate.sh</strong> 是具体的命令</li>
<li>&gt;/dev/null 2&gt;&amp;1&nbsp; &nbsp;<strong>标准输出</strong>到空，<strong>标准错误</strong>输出重定向（等同于）标准输出，即不保存脚本运行中产生的日志，也不保存错误信息（比如脚本不合法。。文件不存在）</li>
<li><strong>&amp;&nbsp;</strong>　&nbsp; 是与nohup一起的，表示<strong>不受终端关闭信号影响，保持后台运行</strong>。如果没有&amp;，在终端关闭时，当前终端执行的nohup进程也会被stop</li></ol>
<p><strong>日志</strong></p>
<p>工具的日志默认是保存在./log下的，有info.log,warn.log,error.log 三个级别的日志。</p>
<div>
<pre class="prettyprint linenums"> migrateLocal over! op statistics:<br />
                      op_status : ALL_OK<br />
                     migrate_ok : 0<br />
                   migrate_fail : 0<br />
                   migrate_skip : 1094<br />
    migrate_condition_not_match : 0<br />
                     start_time : 2018-07-14 11:05:57<br />
                       end_time : 2018-07-14 11:05:59<br />
                      used_time : 2 s</pre>
</div>
<p>上面是脚本运行成功后的输出，因为我之前已经同步过了，所以这里是显示&nbsp;migrate_skip 跳过的文件数。如果有新文件同步成功了，会在migrate_ok显示成功文件数的。</p>
<p>同步结果中还有可以看到些文件是没有同步成功的，具体的失败原因从error.log中就会详细说明。</p>
<p><strong>utf-8</strong></p>
<p>我这边遇到的失败原因全都是文件名乱码，或者是说不是utf-8字符格式，导致工具找不到文件。日志中的信息基本是这个内容，就路径不一样</p>
<div>
<pre class="prettyprint linenums">。。。<br />
localpath /data/xxxxxx not exist! maybe the path contail illegal utf-8 letter<br />
...</pre>
</div>
<p>官方文档已经明确指出<img referrerpolicy="no-referrer"src="https://images2018.cnblogs.com/blog/1426531/201807/1426531-20180714111845886-383794588.jpg" />。</p>
<p>但我们的文件是从本地开发机中通过ftp上传到服务器的。通过对比，那些乱码文件都是含有中文的。</p>
<ol><li>通过ftp到服务器后全部乱码。</li>
<li>通过shell远程touch中文名的文件，正常可同步。</li></ol>
<p>搜索之后知道了ftp是需要设置语言环境的，即字符格式。正在使用的ftp是用默认语言环境，应该是跟系统一样，windows是GBK。linux默认是utf-8</p>
<p><img referrerpolicy="no-referrer"src="https://images2018.cnblogs.com/blog/1426531/201807/1426531-20180714112538273-997357170.jpg" />　　接下来就是删除乱码文件，修改ftp环境，重新同步文件了。</p>
<blockquote><p>发现了乱码文件后，想在终端中手动删除文件，但无法选定。可以使用文件id进行指定。</p>
<div>
<pre class="prettyprint linenums">ls -i  ./  # 列出文件id及文件名<br />
find ./ -inum xxxxx -print -exec rm {} \;  # 获取xxx文件id的文件名传给附加命令 rm 删除 如果是文件夹 -rf 需要加在{}后面</pre>
</div></blockquote>
<p><strong>通知</strong></p>
<p>有文件需要同步时，不想还要查看日志知道是否成功，打算通过webhook的方式自动通知同步结果。就像git有代码提交后，有消息推送的webhook。目前是使用钉钉平台的<a href="https://open-doc.dingtalk.com/docs/doc.htm?treeId=257&amp;articleId=105735&amp;docType=1" rel="external nofollow noreferrer">自定义机器人</a></p>
<ol><li>在群聊中添加自定义机器人，获取webhook地址。</li>
<li>修改cos migration工具的源码，在成功同步后添加通知任务，向webhook地址post数据</li>
<li>群聊中显示同步结果，有成功的文件数，还有失败的文件路径及原因</li></ol>
<p>具体代码请查看我的另外一篇。</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/o8kp0e39.html">asp&period;net mvc使用log4gNetz</a>
		</li>
						<li><a href="https://www.batexi.com/a/oqvzyzy9.html">MVC Razor模板引擎 &commat;RenderBody、&commat;RenderPage、&commat;RenderSection及Html&period;RenderPartial、Html&period;RenderAction</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8ogkdxq.html">jquery 甘特图开发指南</a>
		</li>
						<li><a href="https://www.batexi.com/a/2q7ggejq.html">js jquery实时计算输入字符</a>
		</li>
						<li><a href="https://www.batexi.com/a/jqd3xxz8.html">2016年11月5日--marquee标签、插入百度地图</a>
		</li>
						<li><a href="https://www.batexi.com/a/93xoown9.html">redhat 6&period;7 安装nvidia显卡驱动时出现的问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/8z13ol19.html">Arrays&period;asList引起的惨案</a>
		</li>
						<li><a href="https://www.batexi.com/a/95xyxzz8.html">用Firefly创建第一个工程</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ey32dm9.html">201521123085 《Java程序设计》第12周学习总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/90mlmro8.html">为什么会有OPTIONS请求</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4zw05j9.html">15&lowbar;Python函数名本质</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlj2mmk9.html">alertifyjs</a>
		</li>
						<li><a href="https://www.batexi.com/a/qll53k6q.html">java web获取请求体内容</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kj5wr79.html">蓝桥杯 剪邮票（dfs枚举 &plus; bfs）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1rlk328.html">SQL 自定义四舍五入</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwvr5dl8.html">npm install出现&quot;Unexpected end of JSON input while parsing near&quot;</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7og4rg8.html">Linux 用户管理&lowbar;015</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kjdl4r9.html">利用搜狐新闻语料库训练100维的word2vec&mdash;&mdash;使用python中的gensim模块</a>
		</li>
						<li><a href="https://www.batexi.com/a/8m2zyy2q.html">第三次作业&lpar;1&rpar;  Visual Studio程序安装过程和练习过程</a>
		</li>
						<li><a href="https://www.batexi.com/a/90r0w2m9.html">Java知多少（中）</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/9j13m1l9.html">C&plus;&plus;中的局部变量、全局变量、局部静态变量、全局静态变量的区别</a>
			</li>
						<li><a href="https://www.batexi.com/a/9j13mx49.html">从今天开始 每天记录HTML，CSS 部分的学习笔记</a>
			</li>
						<li><a href="https://www.batexi.com/a/8m20pdpq.html">vue简章</a>
			</li>
						<li><a href="https://www.batexi.com/a/qyykgz2q.html">json与cjson</a>
			</li>
						<li><a href="https://www.batexi.com/a/qv2ljox9.html">树莓派与node&period;js &mdash;&mdash; onoff、dht</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdw2g1v9.html">Python学习笔记第十二周</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pwr2jz8.html">Android内核栈溢出与ROP（CVE-2013-2597）</a>
			</li>
						<li><a href="https://www.batexi.com/a/qnvo4338.html">python中的list按照某一列进行排序的方法</a>
			</li>
						<li><a href="https://www.batexi.com/a/8e4vxyk9.html">SpringBoot  配置文件详解</a>
			</li>
						<li><a href="https://www.batexi.com/a/qyykxzdq.html">JAVA&colon;形参与实参</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
